<?php

/* oci_export.php - SynApp2 utility class
**
   +----------------------------------------------------------------------+
   | SynApp2 Version 1                                                    |
   +----------------------------------------------------------------------+
   | Copyright (c) 2007 - 2010 Richard Howell. All rights reserved.       |
   +----------------------------------------------------------------------+
   | This source file is subject to version 1.01 of the SynApp2 license,  |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.synapp2.org/license/1_01.txt                              |
   | If you did not receive a copy of the SynApp2 license and are unable  |
   | to obtain it through the world-wide-web, please send a note to       |
   | license@synapp2.org so we can mail you a copy immediately.           |
   +----------------------------------------------------------------------+
   | Authors: Richard Howell                                              |
   |                                                                      |
   +----------------------------------------------------------------------+
**
** http://www.synapp2.org
**
** $Id: oci_export.php,v 1.0 2010/10/31 00:00:00 richard Exp $
*/

class oci_export
{
    var $m_SQL = null;

    function do_export()
    {
        global $g_custom, $g_schema;

        $this->m_SQL[] = "--\n-- generated with SynApp2 version " . get_version(true) . "\n--\n";

        $database = $g_custom->get_database();

        $this->m_SQL[] = "-- source database: \"{$database}\"\n--\n\n";

        $table_names = $g_schema->get_table_names();

        if (!empty($table_names))
        {
            foreach ($table_names as $table_name)
            {
                if ($g_schema->is_sys_table($table_name) && $table_name != KEYMAP)
                {
                    continue;
                }

                $rows = get_dbx()->get_query_records("select * from \"{$table_name}\"");

                if (!empty($rows))
                {
                    $this->m_SQL[] = "ALTER TABLE \"{$table_name}\" DISABLE ALL TRIGGERS;\n\n";
                    $this->m_SQL[] = "TRUNCATE TABLE \"{$table_name}\";\n\n";

                    $col_sep = '';

                    $q_col_names = '';

                    foreach ($rows[0] as $col_name => $col_value)
                    {
                        $q_col_names .= "{$col_sep}\"{$col_name}\"";
                        $col_sep = ', ';
                    }

                    foreach ($rows as $i => $row)
                    {
                        $this->m_SQL[] = "INSERT INTO \"{$table_name}\" ({$q_col_names}) VALUES ";

                        $col_sep = '';

                        $q_values = '(';

                        foreach ($row as $col_name => $col_value)
                        {
                            $q_values .= "{$col_sep}'" . get_dbx()->escape_sql_term(trim($col_value)) . "'";
                            $col_sep = ', ';
                        }

                        $q_values .= ');';

                        $this->m_SQL[] = $q_values . "\n";
                    }

                    $this->m_SQL[] = "\n";
                    $this->m_SQL[] = "ALTER TABLE \"{$table_name}\" ENABLE ALL TRIGGERS;\n\n";
                }

                // make sure SynApp2 comment customizations do not get lost [because XE DDL generator does not include the comments]
                //
                $cols_info = $g_schema->get_table_cols_info($table_name);

                foreach ($cols_info as $col_info)
                {
                    if (!empty($col_info['Comment']))
                    {
                        $this->m_SQL[] = "COMMENT ON COLUMN \"{$table_name}\".\"{$col_info['Field']}\" IS '{$col_info['Comment']}';\n\n";
                    }
                }
            }
        }

        $this->m_SQL[] = "-- end\n";
    }

    function save_as($filename)
    {
        global $g_action;

        return file_put_contents(get_app_dir($g_action->get_appid()) . $filename, $this->m_SQL);
    }

    function download()
    {
        // not - implemented
    }
};

////

?>
